// Code generated by go-swagger; DO NOT EDIT.

package events

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
	strfmt "github.com/go-openapi/strfmt"
	swag "github.com/go-openapi/swag"
)

// TicketTypeRequestHandlerFunc turns a function with the right signature into a ticket type request handler
type TicketTypeRequestHandlerFunc func(TicketTypeRequestParams, *ticketboss) middleware.Responder

// Handle executing the request and returning a response
func (fn TicketTypeRequestHandlerFunc) Handle(params TicketTypeRequestParams, principal *ticketboss) middleware.Responder {
	return fn(params, principal)
}

// TicketTypeRequestHandler interface for that can handle valid ticket type request params
type TicketTypeRequestHandler interface {
	Handle(TicketTypeRequestParams, *ticketboss) middleware.Responder
}

// NewTicketTypeRequest creates a new http.Handler for the ticket type request operation
func NewTicketTypeRequest(ctx *middleware.Context, handler TicketTypeRequestHandler) *TicketTypeRequest {
	return &TicketTypeRequest{Context: ctx, Handler: handler}
}

/*TicketTypeRequest swagger:route POST /events/{id}/tickettypes Events ticketTypeRequest

Create a new ticket type for an event.

JSON Response is provided with respective success or fail details.

*/
type TicketTypeRequest struct {
	Context *middleware.Context
	Handler TicketTypeRequestHandler
}

func (o *TicketTypeRequest) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewTicketTypeRequestParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *ticketboss
	if uprinc != nil {
		principal = uprinc.(*ticketboss) // this is really a ticketboss, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// TicketTypeRequestBody ticket type request body
// swagger:model TicketTypeRequestBody
type TicketTypeRequestBody struct {

	// amount
	Amount float64 `json:"amount,omitempty"`

	// description
	Description string `json:"description,omitempty"`

	// name
	Name string `json:"name,omitempty"`
}

// Validate validates this ticket type request body
func (o *TicketTypeRequestBody) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *TicketTypeRequestBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *TicketTypeRequestBody) UnmarshalBinary(b []byte) error {
	var res TicketTypeRequestBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
